package minecraft.player;

public abstract class Character {
    private String name;
    private int health;
    private int maxHealth;
    private int attackPower;
    private int defensePower;

    public Character(String name, int health, int maxHealth, int attackPower, int defensePower) {
        this.setName(name);
        this.setHealth(health);
        this.setMaxHealth(maxHealth);
        this.setAttackPower(attackPower);
        this.setDefensePower(defensePower);
    }

    public void attack(NPC who) {
        int realAttackPower = Math.max(0, getAttackPower() - who.getDefensePower());
        who.setHealth(who.getHealth() - realAttackPower);

        System.out.println(getName() + " zautotocil na " + who.getName() + " damage je " + realAttackPower);
    }

    public void attack(Creeper who) {
        int realAttackPower = Math.max(0, getAttackPower() - who.getDefensePower());

        who.setHealth(who.getHealth() - realAttackPower);
        who.setBombTimer(1.5);

        System.out.println(getName() + " zautotocil na " + who.getName() + " damage je " + realAttackPower);
    }

    public void attack(Steve who) {
        if (who.isGodMode())
            return;

        int realAttackPower = Math.max(0, getAttackPower() - who.getDefensePower());

        who.setHealth(who.getHealth() - realAttackPower);
        System.out.println(getName() + " zautotocil na " + who.getName() + " damage je " + realAttackPower);
    }

    public String getName() {
        return name;
    }

    private void setName(String name) {
        this.name = name;
    }

    public int getHealth() {
        return health;
    }

    public void setHealth(int health) {
        this.health = health;
    }

    public int getMaxHealth() {
        return maxHealth;
    }

    public void setMaxHealth(int maxHealth) {
        this.maxHealth = maxHealth;
    }

    public int getAttackPower() {
        return attackPower;
    }

    public void setAttackPower(int attackPower) {
        this.attackPower = attackPower;
    }

    public int getDefensePower() {
        return defensePower;
    }

    public void setDefensePower(int defensePower) {
        this.defensePower = defensePower;
    }

    // pre lepsie printy
    @Override
    public String toString() {
        return "Character{" +
                "name='" + name + '\'' +
                ", health=" + health +
                ", maxHealth=" + maxHealth +
                ", attackPower=" + attackPower +
                ", defensePower=" + defensePower +
                '}';
    }
}
